unit gps_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls;

const
  Version_ = ' GPS - v1.7.3 by Didier GERARD';

type

  { TWdMain }

  TWdMain = class(TForm)
    Edit2: TEdit;
    EdLaDeg: TEdit;
    EdLoDeg: TEdit;
    Edit1: TEdit;
    EdLatitude: TEdit;
    EdLongitude: TEdit;
    EdLaMn: TEdit;
    EdLoMn: TEdit;
    EdLaSe: TEdit;
    EdLoSe: TEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Panel1: TPanel;
    Panel2: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    procedure EdLoDegChange(Sender: TObject);
    procedure EdLaDegChange(Sender: TObject);
    procedure EdLoMnChange(Sender: TObject);
    procedure EdLaMnChange(Sender: TObject);
    procedure EdLoSeChange(Sender: TObject);
    procedure EdLaSeChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure RadioButton1Change(Sender: TObject);
    procedure RadioButton2Change(Sender: TObject);
    procedure RadioButton5Change(Sender: TObject);
    procedure RadioButton6Change(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdMain: TWdMain;

implementation

{$R *.lfm}

{ TWdMain }

function RealToStr(Reel: real; Decimal: byte): string;
var
  s: string;
begin
  Str(Reel: 0: Decimal, s); //avec 2 décimales
  Result := s;
end;

function StrToReal(s: string): real;
var
  r: real;
  Pos: integer;
begin
  r := 0;
  if s <> '' then
  begin
    if s[Length(s)] = '.' then
      Delete(s, Length(s), 1);
    Val(s, r, Pos);
    if Pos > 0 then
      Val(Copy(s, 1, Pos - 1), r, Pos);
  end;
  Result := r;
end;

function Format_Virgule(s: string): string;
var
  t: string;
  n: integer;
begin
  t := s;
  for n := 1 to Length(t) do
  begin
    if t[n] = ',' then
      t[n] := '.';
  end;
  Result := t;
end;

function Format_Chiffre(s: string): string;
var
  t: string;
  n: integer;
  Vr: boolean;
begin
  t := '';
  if s <> '' then
  begin
    Vr := False;
    for n := 1 to Length(s) do
      case s[n] of
        '0'..'9', '.':
        begin
          if s[n] = '.' then
          begin
            if not Vr then
            begin
              t := t + '.';
              Vr := True;
            end;
          end
          else
          begin
            t := t + s[n];
          end;
        end;
      end;
  end;
  Result := t;
end;

procedure DMS_vers_DD(Select: integer);
var
  LaDeg, LaMn, LaSe: real;
  LoDeg, LoMn, LoSe: real;
  Latitude, Longitude: real;
  La, Lo: string;
begin
  with WdMain do
  begin
    //----- Latitude -----
    //Degrés
    if EdLaDeg.Text = '' then
    begin
      LaDeg := 0;
    end
    else
    begin
      EdLaDeg.Text := Format_Chiffre(Format_Virgule(EdLaDeg.Text));
      EdLaDeg.SelStart := Length(EdLaDeg.Text);
      LaDeg := StrToReal(EdLaDeg.Text);
    end;
    //Degrés entre 0 et 90°
    if LaDeg > 90 then
    begin
      ShowMessage('Les degrés en latitude doivent être compris entre 0 et 90°');
      EdLaDeg.Text := '90';
    end;
    //Minutes
    if EdLaMn.Text = '' then
    begin
      LaMn := 0;
    end
    else
    begin
      EdLaMn.Text := Format_Chiffre(Format_Virgule(EdLaMn.Text));
      EdLaMn.SelStart := Length(EdLaMn.Text);
      LaMn := StrToReal(EdLaMn.Text);
    end;
    //Minutes entre 0 et 59
    if LaMn > 59 then
    begin
      ShowMessage('Les minutes en latitude doivent être compris entre 0 et 59''');
      EdLaMn.Text := '59';
    end;
    //Secondes
    if EdLaSe.Text = '' then
    begin
      LaSe := 0;
    end
    else
    begin
      EdLaSe.Text := Format_Chiffre(Format_Virgule(EdLaSe.Text));
      EdLaSe.SelStart := Length(EdLaSe.Text);
      LaSe := StrToReal(EdLaSe.Text);
    end;
    //Secondes entre 0 et 59
    if LaSe > 59 then
    begin
      ShowMessage('Les secondes en latitude doivent être compris entre 0 et 59''');
      EdLaSe.Text := '59';
    end;
    //DD=Degré+min/60+sec/3600
    Latitude := LaDeg;
    if LaMn > 0 then
      Latitude := Latitude + (LaMn / 60);
    if LaSe > 0 then
      Latitude := Latitude + (LaSe / 3600);
    EdLatitude.Text := RealToStr(Latitude, 8);
    //---- Longitude -----
    //Degrés
    if EdLoDeg.Text = '' then
    begin
      LoDeg := 0;
    end
    else
    begin
      EdLoDeg.Text := Format_Chiffre(Format_Virgule(EdLoDeg.Text));
      EdLoDeg.SelStart := Length(EdLoDeg.Text);
      LoDeg := StrToReal(EdLoDeg.Text);
    end;
    //Degrés entre 0 et 180
    if LoDeg > 180 then
    begin
      ShowMessage('Les degrés en latitude doivent être compris entre 0 et 180°');
      EdLoDeg.Text := '180';
    end;
    //Minutes
    if EdLoMn.Text = '' then
    begin
      LoMn := 0;
    end
    else
    begin
      EdLoMn.Text := Format_Chiffre(Format_Virgule(EdLoMn.Text));
      EdLoMn.SelStart := Length(EdLoMn.Text);
      LoMn := StrToReal(EdLoMn.Text);
    end;
    //Minutes entre 0 et 59
    if LoMn > 59 then
    begin
      ShowMessage('Les minutes en latitude doivent être compris entre 0 et 59''');
      EdLoMn.Text := '59';
    end;
    //Secondes
    if EdLoSe.Text = '' then
    begin
      LoSe := 0;
    end
    else
    begin
      EdLoSe.Text := Format_Chiffre(Format_Virgule(EdLoSe.Text));
      EdLoSe.SelStart := Length(EdLoSe.Text);
      LoSe := StrToReal(EdLoSe.Text);
    end;
    //Secondes entre 0 et 59
    if LoSe > 59 then
    begin
      ShowMessage('Les secondes en latitude doivent être compris entre 0 et 59''');
      EdLoSe.Text := '59';
    end;

    Longitude := LoDeg;
    if LoMn > 0 then
      Longitude := Longitude + (LoMn / 60);
    if LoSe > 0 then
      Longitude := Longitude + (LoSe / 3600);
    //Est vers Ouest
    if RadioButton6.Checked then
      EdLongitude.Text := '-' + RealToStr(Longitude, 8)
    else
      EdLongitude.Text := RealToStr(Longitude, 8);
    //DMS
    La := EdLaDeg.Text + '°' + EdLaMn.Text + '''' + EdLaSe.Text + '"';
    if RadioButton1.Checked then
      La := La + 'N'
    else
      La := La + 'S';
    Lo := EdLoDeg.Text + '°' + EdLoMn.Text + '''' + EdLoSe.Text + '"';
    if RadioButton5.Checked then
      Lo := Lo + 'E'
    else
      Lo := Lo + 'O';
    Edit2.Text := La + ',' + Lo;
    //DD
    La := EdLatitude.Text;
    if RadioButton2.Checked then
      La := '-' + La;
    Lo := EdLongitude.Text;
    Edit1.Text := La + ',' + Lo;
  end;
end;

procedure TWdMain.RadioButton6Change(Sender: TObject);
begin
  DMS_vers_DD(12);
end;

procedure TWdMain.EdLaDegChange(Sender: TObject);
begin
  DMS_vers_DD(3);
end;

procedure TWdMain.EdLoMnChange(Sender: TObject);
begin
  DMS_vers_DD(14);
end;

procedure TWdMain.EdLoDegChange(Sender: TObject);
begin
  DMS_vers_DD(13);
end;

procedure TWdMain.EdLaMnChange(Sender: TObject);
begin
  DMS_vers_DD(4);
end;

procedure TWdMain.EdLoSeChange(Sender: TObject);
begin
  DMS_vers_DD(15);
end;

procedure TWdMain.EdLaSeChange(Sender: TObject);
begin
  DMS_vers_DD(5);
end;

procedure TWdMain.RadioButton1Change(Sender: TObject);
begin
  DMS_vers_DD(1);
end;

procedure TWdMain.RadioButton2Change(Sender: TObject);
begin
  DMS_vers_DD(2);
end;

procedure TWdMain.RadioButton5Change(Sender: TObject);
begin
  DMS_vers_DD(11);
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  WdMain.Caption := Version_;
  //Init
  EdLaDeg.MaxLength := 2;//0 a 90°
  EdLaMn.MaxLength := 2; //0 a 59'
  EdLaSe.MaxLength := 0;

  EdLoDeg.MaxLength := 3; //0 a 180°
  EdLoMn.MaxLength := 2;  //0 a 59'
  EdLoSe.MaxLength := 0;

  DMS_vers_DD(0);
end;

end.
